	
	subroutine psv_read

	include 'common.h'

	real, dimension (nx) :: tmp1,tmp2
!hpf$	distribute (*) :: tmp1,tmp2

	character*80 file

	if(it==1)then
        file=seisfile(1:lnblnk(seisfile))//'_t'
        open(unit=10,file=file,form='unformatted')
        file=seisfile(1:lnblnk(seisfile))//'_r'
        open(unit=11,file=file,form='unformatted')
	endif

	if(it==1)then
	write(*,*)' Reading buffer at it = ',it
	read(10)seisx
	write(*,*)minval(seisx),' < seisx < ',maxval(seisx)
	write(*,*)minval(seisx(:,nbuf)),' < seisx < ',maxval(seisx(:,nbuf))
	read(11)seisz
	write(*,*)minval(seisz),' < seisz < ',maxval(seisz)
	write(*,*)minval(seisz(:,nbuf)),' < seisz < ',maxval(seisz(:,nbuf))
	endif

	do i=1,nr
	iout=(i-1)*nt+it
	tmp1=theta1(:,izrec)
	if(mod(it,nbuf)<>0)tmp2=seisx(:,mod(it,nbuf))
	if(mod(it,nbuf)==0)tmp2=seisx(:,nbuf)
c	write(*,*)minval(tmp2),' < tmp2 < ',maxval(tmp2)
	call rec_int(tmp1,nx,rec_loc(i)/180.*pi,tmp2,seis(1,iout))
c	write(*,*)seis(1,iout)
	tmp1=theta2(:,izrec)
	if(mod(it,nbuf)<>0)tmp2=seisz(:,mod(it,nbuf))
	if(mod(it,nbuf)==0)tmp2=seisz(:,nbuf)
c	write(*,*)minval(tmp2),' < tmp2 < ',maxval(tmp2)
	call rec_int(tmp1,nx,rec_loc(i)/180.*pi,tmp2,seis(2,iout))
c	write(*,*)seis(2,iout)
	enddo


        if(mod(it,nbuf)==0.and.it<nt)then
        write(*,*)' Reading buffer at it = ',it
        read(10)seisx
        write(*,*)minval(seisx),' < seisx < ',maxval(seisx)
        read(11)seisz
        write(*,*)minval(seisz),' < seisz < ',maxval(seisz)
        endif




	if(it==nt)then
	write(*,*)' Flushing out seismograms ... '
	file=seisfile(1:lnblnk(seisfile))//'_at'
	open(unit=10,file=file)
	file=seisfile(1:lnblnk(seisfile))//'_ar'
	open(unit=11,file=file)
	nrt=nt/isamp
	do i=1,nr*nrt
	write(10,*)seis(1,i)
	write(11,*)seis(2,i)
	enddo
	close(10)
	close(11)
	endif


	return
	end
	

c ---------------------------------------------

	subroutine  rec_int(x,nx,xr,f,out)

c this routine interpolates linearly a scalar field known at 
c x(0:nx) and y(0:ny) locations to an arbitrary location
c within xmax and ymax.
c The receiver locations are xr,  the scalar input
c field is plane and the function value at xr  is
c out.

	real x(nx)
	real xr,out
	real f(nx)

	do i=1,nx-1
	if(xr .ge. x(i) .and. xr .lt. x(i+1) ) then
	ilow=i
	iup =i+1
	dx=x(i+1)-x(i)
	hx=xr-x(i)
	endif
	enddo

	f1=f(ilow)
	f2=f(iup)

	out = f1 + (f2-f1)/dx*hx

	return
	end

c ---------

	subroutine time_check(i,nt)

	include '/usr/include/cm/timer-fort.h'

	call cm_timer_stop(0)
	busy=cm_timer_read_cm_busy(0)
	write(*,*)' Busy sofar : ',busy/60.,' min.'
	elapsed=cm_timer_read_elapsed(0)
	write(*,*)' Elapsed sofar : ',elapsed/60.,' min.'
	write(*,*)' Pred. total CM-busy time : ',busy/i*nt/60,' min.'
	write(*,*)' Pred. total CM-elapsed time : ',elapsed/i*nt/60,' min.'
	call cm_timer_start(0)

	return
	end

	
	subroutine psv_output

	include 'common.h'

	real, dimension (nx) :: tmp1,tmp2
!hpf$	distribute (*) :: tmp1,tmp2

	character*80 file


	if(isnap<>0.and.it==1)then
	file=seisfile(1:lnblnk(seisfile))//'_t_snp'
	open(unit=98,file=file,status='unknown')
	file=seisfile(1:lnblnk(seisfile))//'_r_snp'
	open(unit=99,file=file,status='unknown')
	endif

	write(*,*)izrec
	if(mod(it,isamp)==0)then
	do i=1,nr
	iout=(i-1)*nt+it
	forall(ix=1:nx)tmp1(ix)=theta1(ix,izrec)
	forall(ix=1:nx)tmp2(ix)=u21(ix,izrec)
c	call rec_int(tmp1,nx,rec_loc(i)/180.*pi,tmp2,seis(1,iout))
	forall(ix=1:nx)tmp1(ix)=theta2(ix,izrec)
	forall(ix=1:nx)tmp2(ix)=u22(ix,izrec)
c	call rec_int(tmp1,nx,rec_loc(i)/180.*pi,tmp2,seis(2,iout))
	enddo
	endif

	if(mod(it,icheckpoint)==0)then
	write(*,*)' Flushing out seismograms ... '
	file=seisfile(1:lnblnk(seisfile))//'_t'
	open(unit=10,file=file)
	file=seisfile(1:lnblnk(seisfile))//'_r'
	open(unit=11,file=file)
	nrt=nt/isamp
	do i=1,nr*nrt
	write(10,*)seis(1,i)
	write(11,*)seis(2,i)
	enddo
	close(10)
	close(11)
	endif


c snap output

	if(isnap<>0.and.mod(it,isnap).eq.0)then
	write(*,*)' Outputting snap : ',it/isnap
	do ix=1,nx,2
	do iz=1,nz,2
	write(98,*)u21(ix,iz)
	write(99,*)u22(ix,iz)
	enddo	
	enddo
	endif


	return
	end
	

c ---------------------------------------------

	subroutine  rec_int(x,nx,xr,f,out)

c this routine interpolates linearly a scalar field known at 
c x(0:nx) and y(0:ny) locations to an arbitrary location
c within xmax and ymax.
c The receiver locations are xr,  the scalar input
c field is plane and the function value at xr  is
c out.

	real x(nx)
	real xr,out
	real f(nx)

	do i=1,nx-1
	if(xr .ge. x(i) .and. xr .lt. x(i+1) ) then
	ilow=i
	iup =i+1
	dx=x(i+1)-x(i)
	hx=xr-x(i)
	endif
	enddo

	f1=f(ilow)
	f2=f(iup)

	out = f1 + (f2-f1)/dx*hx

	return
	end

	
	include 'psv_deriv.f'

	subroutine psv_evolution

	include 'common.h'

	use derivative

	real, dimension (nx,nz)  :: rtemp1,rtemp2
	real, dimension (4,nx,nz) :: e,s 

!hpf$ align with tt :: rtemp1,rtemp2
!hpf$ align (*,:,:) with tt(:,:) :: e,s


	if(mod(it,icheck)==0)then
	write(*,*)' Time step   ',it,'   Max(u_r)  =  ',maxval(u(it2,2,:,:))
	write(*,*)' Time step   ',it,'   Min(u_r)  =  ',minval(u(it2,2,:,:))
	write(*,*)' Time step   ',it,'   Max(u_t)  =  ',maxval(u(it2,1,:,:))
	write(*,*)' Time step   ',it,'   Min(u_t)  =  ',minval(u(it2,1,:,:))
c	write(*,*)'                   Maxloc(u)  =  ',maxloc(u)
	if(maxval(u)>1.)then
	write(*,*)' unstable at  it = ',it
	stop
	endif
	endif


c symmetry with respect to source location

	forall(ix=1:isx-1)u(it2,1,isx-ix,:)=-u(it2,1,isx+ix,:)	
	forall(ix=1:isx)u(it2,2,isx+1-ix,:)=u(it2,2,isx+ix,:)	

c free surface


        forall (iz=1:izfree-1) u(it2,2,:,izfree-iz)=
     &                                          u(it2,2,:,izfree+iz)
        forall (iz=1:izfree) u(it2,1,:,izfree+1-iz)=
     &                                          u(it2,1,:,izfree+iz)


c eoshift simulations at sides and at bottom

	u(it2,1,nx-izfree:nx,:)=0.
	u(it2,2,nx-izfree:nx,:)=0.
	u(it2,1,:,nz-izfree:nz)=0.
	u(it2,2,:,nz-izfree:nz)=0.


c end-of-shift simulation to omit eoshift 


c absorbing boundaries


c calculate strain elements :
c		e1 = eps_r r
c		e2 = eps_phi phi
c		e3 = eps_theta theta
c		e4 = eps_r theta

c e1
c
c e1 = d_r u^r 

	e=0.
	rtemp2=u(it2,2,:,:)
	call pder(rtemp1,rtemp2,dr,nx,nz,-1,2,nop)	
	e(1,:,:)=rtemp1

c e2 = u^r/r + 1/r cotg theta u^theta

	call inter(rtemp1,rtemp2,
     &		  nx,nz,-1,2,nop)

	e(2,:,:)=rtemp1*r1inv

c we need this later

	e(3,:,:) = e(2,:,:)

	rtemp2=u(it2,1,:,:)
	call inter(rtemp1,rtemp2,nx,nz,-1,1,nop)

	e(2,:,:) = e(2,:,:)+ cot2*rtemp1*r1inv

c e3 = 1/r d_theta u^theta + 1/r u^r

        call pder(rtemp1,rtemp2,dphi,nx,nz,-1,1,nop)

	e(3,:,:) = e(3,:,:) + rtemp1*r1inv

c e4 = .5 ( 1/r d_theta u^r + d_r u^theta - 1/r u_theta)

	rtemp2=u(it2,2,:,:)	
        call pder(rtemp1,rtemp2,dphi,nx,nz,1,1,nop)
	s(1,:,:)=rtemp1	
	rtemp2=u(it2,1,:,:)
        call pder(rtemp1,rtemp2,dr,nx,nz,1,2,nop)

	e(4,:,:) = 0.5*(r2inv*s(1,:,:) + rtemp1)

        call inter(rtemp1,rtemp2,nx,nz,1,2,nop)

	e(4,:,:)=e(4,:,:)-0.5*rtemp1*r2inv

c set off diag elements zero at source

	e(4,isx,:)=0.

c calculate stress


	s=0.

	s(1,:,:) = (lam+2*mu)*e(1,:,:)+lam*(e(2,:,:)+e(3,:,:))

	s(2,:,:) = (lam+2*mu)*e(2,:,:)+lam*(e(1,:,:)+e(3,:,:))

	s(3,:,:) = (lam+2*mu)*e(3,:,:)+lam*(e(2,:,:)+e(1,:,:))

	s(4,:,:)=2*mu*e(4,:,:)

c moments

	if(source_type==2)then
	s(1,isx:isx+1,isz:isz+1)=s(1,isx:isx+1,isz:isz+1)+so(1,it)
	s(2,isx:isx+1,isz:isz+1)=s(2,isx:isx+1,isz:isz+1)+so(1,it)
	s(3,isx:isx+1,isz:isz+1)=s(3,isx:isx+1,isz:isz+1)+so(1,it)
	endif

c boundary conditions (stress) -> antisymmetry

	forall(iz=1:izfree)s(1,:,izfree+1-iz)=-s(1,:,izfree+iz)
	forall(iz=1:izfree)s(2,:,izfree+1-iz)=-s(2,:,izfree+iz)
	forall(iz=1:izfree)s(3,:,izfree+1-iz)=-s(3,:,izfree+iz)
	forall(iz=1:izfree-1)s(4,:,izfree-iz)=-s(4,:,izfree+iz)
	s(4,:,izfree)=0.	


c calculate acceleration

c e(1,:,:) and e(2,:,:) will carry acc theta and r, resp.
c e(3-4,:,:) act as temporay arrays

c for u_r :
c     e(3,:,:)=d_r sigma_r^r
c     e(4,:,:)=d_theta sigma_theta^r

	rtemp2=s(1,:,:)
        call pder(rtemp1,rtemp2,dr,nx,nz,1,2,nop)
	e(3,:,:)=rtemp1
	rtemp2=s(4,:,:)
        call pder(rtemp1,rtemp2,dphi,nx,nz,-1,1,nop)
	e(4,:,:)=rtemp1

	e(2,:,:) =   r2inv * e(4,:,:)+e(3,:,:) 

	
c     e(1,:,:) = s(1) -> u_r
c     e(3,:,:) = s(2) -> u_r
c     e(4,:,:) = s(3) -> u_r

	rtemp2=s(1,:,:)
	call inter(rtemp1,rtemp2,nx,nz,1,2,nop) 
	e(1,:,:)=rtemp1
	rtemp2=s(2,:,:)
	call inter(rtemp1,rtemp2,nx,nz,1,2,nop) 
	e(3,:,:)=rtemp1
	rtemp2=s(3,:,:)
	call inter(rtemp1,rtemp2,nx,nz,1,2,nop) 
	e(4,:,:)=rtemp1
	rtemp2=s(4,:,:)
	call inter(rtemp1,rtemp2,nx,nz,-1,1,nop) 

	e(2,:,:) = rhoinv * ( e(2,:,:) + r2inv*(2*e(1,:,:)-e(3,:,:)-e(4,:,:)
     &			      + rtemp1*cot2 )    ) 
	
c for u_theta:

c 	e(3,:,:)=d_r sigma_r^theta
c	e(4,:,:)=d_theta sigma_theta^theta
c	e(5,:,:)=s2 -> u_phi


	rtemp2=s(4,:,:)
        call pder(rtemp1,rtemp2,dr,nx,nz,-1,2,nop)
	e(3,:,:)=rtemp1
	rtemp2=s(3,:,:)
        call pder(rtemp1,rtemp2,dphi,nx,nz,1,1,nop)
	e(4,:,:)=rtemp1

	forall (ix=1:isx-1) e(1,ix,:) = r1inv(ix,:) * e(4,ix,:) + e(3,ix,:) 
	forall (ix=isx+1:nx) e(1,ix,:) = r1inv(ix,:) * e(4,ix,:) + e(3,ix,:) 

	rtemp2=s(4,:,:)
        call inter(rtemp1,rtemp2,nx,nz,-1,2,nop)
	e(3,:,:)=rtemp1
	rtemp2=s(2,:,:)
        call inter(rtemp1,rtemp2,nx,nz,1,1,nop)
	e(4,:,:)=rtemp1
	rtemp2=s(3,:,:)
        call inter(rtemp1,rtemp2,nx,nz,1,1,nop)

	forall (ix=1:isx-1)  e(1,ix,:) = e(1,ix,:) + r1inv(ix,:)* 
     &                       ( (-e(4,ix,:)+rtemp1(ix,:))*cot1(ix,:)+3*e(3,ix,:) )
	forall (ix=isx+1:nx) e(1,ix,:) = e(1,ix,:) + r1inv(ix,:)* 
     &                       ( (-e(4,ix,:)+rtemp1(ix,:))*cot1(ix,:)+3*e(3,ix,:) )
	e(1,isx,:) = 0.
	
	e(1,:,:)=e(1,:,:)*rhoinv


c add source term

	if(source_type==1)then
	e(2,:,:)=e(2,:,:)+gauss*so(1,it)*rhoinv
	endif	

c extrapolate


	u(it3,:,:,:)= 2*u(it2,:,:,:) - u(it1,:,:,:) + e(1:2,:,:)*(dt**2)



	return
	end	

c
c
c
c PSV wave propagation in spherical coordinates
c --------------------------------------------
c
c
c
c                                        Heiner Igel, 1994
c

	program main

	include 'common.h'

c timing specs

        real*4 dtime,delta,tarray(2)
        external dtime

c input

	call psv_input

c initialization

	call psv_init


c check

	call psv_check


c time evolution

	it1=1
	it2=2
	it3=2

c timing

	t0=secnds(0.0)

	do it=1,nt

	it2=it1
	it1=it3


	if(aa==1000.)then
	 if(it.ge.it0)then
		call psv_evolution
	  endif
	else
	  call psv_evolution
	endif
	
	call psv_output

	it3=it2

c timing

	if(aa.ne.1000.)then
	if(mod(it,icheck)==0)then
        call time_check(it,nt,icheck,t0)
	endif
	else
	if(it.gt.it0)then
	if(mod(it,icheck)==0)then
        call time_check(it,nt,icheck,t0)
	endif
	endif
	endif


	enddo

	end program main

c ---------------------------------------------

	subroutine  rec_int(x,nx,xr,f,out)

c this routine interpolates linearly a scalar field known at 
c x(0:nx) and y(0:ny) locations to an arbitrary location
c within xmax and ymax.
c The receiver locations are xr,  the scalar input
c field is plane and the function value at xr  is
c out.

	real x(nx)
	real xr,out
	real f(nx)

	do i=1,nx-1
	if(xr .ge. x(i) .and. xr .lt. x(i+1) ) then
	ilow=i
	iup =i+1
	dx=x(i+1)-x(i)
	hx=xr-x(i)
	endif
	enddo

	f1=f(ilow)
	f2=f(iup)

	out = f1 + (f2-f1)/dx*hx

	return
	end

	subroutine psv_input

	include 'common.h'

	character*15 junk
	character*50 file

	real, dimension(101) :: rch,much,lamch,rhoch

c file input
	
	Rmax=6371000.

	read(*,*)junk
	read(*,1)junk,seisfile
	read(*,1)junk,recfile
	read(*,1)junk,snapfile
	read(*,*)junk
	read(*,2)junk,nt
	read(*,3)junk,dt
	read(*,*)junk
	read(*,2)junk,izfree
	read(*,2)junk,iord
	read(*,2)junk,nop
	read(*,3)junk,aabsorb
	read(*,2)junk,nabsorb
	read(*,3)junk,Dmax
	read(*,3)junk,Thetamax
	read(*,*)junk
	read(*,2)junk,model_type
	read(*,3)junk,vp0
	read(*,3)junk,vs0
	read(*,3)junk,rho0
	read(*,*)junk
	read(*,2)junk,isx
	read(*,3)junk,sdepth
	read(*,3)junk,aa
	read(*,2)junk,it0
	read(*,3)junk,alpha
	read(*,2)junk,source_type
	read(*,*)junk
	read(*,2)junk,idisp
	read(*,2)junk,isnap
	read(*,2)junk,icolor
	read(*,2)junk,icomp
	read(*,*)junk
	read(*,2)junk,ixa
	read(*,2)junk,ixe
	read(*,2)junk,irec
	read(*,2)junk,izrec
	read(*,2)junk,isamp
	read(*,*)junk
	read(*,2)junk,ifork
	read(*,2)junk,icheck
	read(*,2)junk,icheckpoint
	read(*,3)junk,rmax
 1	format(a,a)
 2	format(a,i8)
 3	format(a,f10.6)

c read receiver coords

	open(unit=10,file=recfile)
	read(10,*)nr
	do i=1,nr
	read(10,*)rec_loc(i)
	enddo
	close(10)

c the space grid

	dr=Dmax/(nz-2*izfree)
	dphi=(Thetamax/180*pi)/nx


c initialize Radius

	forall(iz=1:nz)vr2(iz)=Rmax-(iz-izfree)*dr
	forall(iz=1:nz)vr1(iz)=vr2(iz)-.5*dr

	forall(ix=1:nx,iz=1:nz)r1(ix,iz)=vr1(iz)
	forall(ix=1:nx,iz=1:nz)r2(ix,iz)=vr2(iz)


c read model

	if(model_type==1)then

	vrho=rho0
	vmu=vrho*vs0**2
	vlam=vrho*vp0**2-2*vmu

        forall(j=1:nz)rho(:,j)=vrho(j)
        forall(j=1:nz)mu(:,j)=vmu(j)
        forall(j=1:nz)lam(:,j)=vlam(j)


	elseif(model_type==2)then


	call prem

	vrho=vrho*1000.		
	vmu=vmu*1000.
	vlam=vlam*1000.

	vmu=vrho*vmu**2
	vlam=vrho*vlam**2-2*vmu

        forall(j=1:nz)rho(:,j)=vrho(j)
	forall(j=1:nz)mu(:,j)=vmu(j)
	forall(j=1:nz)lam(:,j)=vlam(j)

	elseif(model_type==3)then

	call homo

	vrho=vrho*1000.		
	vmu=vmu*1000.
	vlam=vlam*1000.

	vmu=vrho*vmu**2
	vlam=vrho*vlam**2-2*vmu

	forall(j=1:nz)rho(:,j)=vrho(j)	
	forall(j=1:nz)mu(:,j)=vmu(j)	
	forall(j=1:nz)lam(:,j)=vlam(j)	

	elseif(model_type==4)then

	nzch=101
	open(unit=10,file='DATAV/homo100p_model')
	do i=101,1,-1
	read(10,*)rch(i),rhoch(i),lamch(i),much(i)
	enddo
	close(10)

	write(*,*)' Interpolating ... '
	do i=1,nz
c	write(*,*)' Interpolating at r = ',vr1(i)/1000,'km'
	if(vr1(i).gt.6371000.)then
	vrho(i)=rhoch(101)
	vlam(i)=lamch(101)
	vmu(i)=much(101)
	else
	call rint(rch,nzch,vr1(i),rhoch,vrho(i))
	call rint(rch,nzch,vr1(i),much,vmu(i))
	call rint(rch,nzch,vr1(i),lamch,vlam(i))
	endif
	enddo

	forall(j=1:nz)rho(:,j)=vrho(j)	
	forall(j=1:nz)mu(:,j)=vmu(j)	
	forall(j=1:nz)lam(:,j)=vlam(j)	

	open(unit=10,file=seisfile(1:lnblnk(seisfile))//'_model')
	do i=1,nz
	write(10,*)vr1(i),vrho(i),vlam(i),vmu(i)
	enddo
	close(10)


	elseif(model_type==5)then

c acoustic model

	call premnoc

	vmu=0.
	vrho=vrho*1000.		
	vmu=vmu*1000.
	vlam=vlam*1000.

	vmu=vrho*vmu**2
	vlam=vrho*vlam**2-2*vmu

        forall(j=1:nz)rho(:,j)=vrho(j)
	forall(j=1:nz)mu(:,j)=vmu(j)
	forall(j=1:nz)lam(:,j)=vlam(j)

	mu=0.

	endif

	call fd_absorb_model

	end

c -------------------------------------------
        subroutine add_num_to_char(file,i)
c -------------------------------------------


        implicit none

        character*50 file
        character*4 ichar

        integer i,in,lnblnk

        if(i.lt.10)then
        write(ichar,'(i1)') i
        in=1
        elseif(i.lt.100)then
        write(ichar,'(i2)') i
        in=2
        elseif(i.lt.1000)then
        write(ichar,'(i3)') i
        in=3
        elseif(i.lt.10000)then
        write(ichar,'(i4)') i
        in=4
        else
        write(*,*)' Warning : number too large !!! '
        endif
 
        file = file(1:lnblnk(file))//ichar(1:in)
 
        return
        end

c -----------------------------------
c
c progam prem to generate radially symmetric earth models
c
c izfree included  4-8-94

	subroutine prem

	include 'common.h'

	ddr=0.001*dmax/(nz-2*izfree)
	re=6371.0

	write(*,*)' Generating Earth model .... '
	write(*,*)' No. of radii  :  ',nz
	write(*,*)' izfree     : ',izfree
	write(*,*)' Max depth :      ',dmax
	write(*,*)' '

	do i=1,nz

	depth=(i-izfree)*ddr
	dist=re-depth
	x=dist/re




c	if(dist.lt.6371.and.dist.ge.6368)then
c	vrho(i)=1.020
c	vlam(i) =1.450
c	vmu(i) =0.
	if(dist.ge.6356)then
	vrho(i)=2.6
	vlam(i)=5.8
	vmu(i)=3.2
	elseif(dist.lt.6356.and.dist.ge.6346.6)then 
	vrho(i)=2.9
	vlam(i)=6.8
	vmu(i)=3.9
	elseif(dist.lt.6346.6.and.dist.ge.6151)then 
	vrho(i)=2.691+.6924*x
	vlam(i)=4.1875+3.9382*x
	vmu(i)=2.1519+2.3481*x
	elseif(dist.lt.6151.and.dist.ge.5971)then 
	vrho(i)=7.1089-3.8045*x
	vlam(i)=20.3926-12.2569*x
	vmu(i)=8.9496-4.4597*x
	elseif(dist.ge.5771)then 
	vrho(i)=11.2494-8.0298*x
	vlam(i)=39.7027-32.6166*x
	vmu(i)=22.3512-18.5856*x
	elseif(dist.lt.5771.and.dist.ge.5701)then 
	vrho(i)=5.3197-1.4836*x
	vlam(i)=19.0957-9.8672*x
	vmu(i)=9.9839-4.9324*x
	elseif(dist.lt.5701.and.dist.ge.5600)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3
	vlam(i)=29.2766-23.6027*x+5.5242*x**2-2.5514*x**3
	vmu(i)=22.3459-17.2473*x-2.0834*x**2+0.9783*x**3
	elseif(dist.lt.5600.and.dist.ge.3630)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3
	vlam(i)=24.9520-40.4673*x+51.4832*x**2-26.6419*x**3
	vmu(i)=11.1671-13.7818*x+17.4575*x**2-9.2777*x**3
	elseif(dist.lt.3630.and.dist.ge.3480)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3 
	vlam(i)=15.3891-5.3181*x+5.5242*x**2-2.5514*x**3
	vmu(i)=6.9254+1.4672*x-2.0834*x**2+.9783*x**3
	elseif(dist.lt.3480.and.dist.ge.1221.5)then 
	vrho(i)=12.5815-1.2638*x-3.6426*x**2-5.5281*x**3
	vlam(i)=11.0487-4.0362*x+4.8023*x**2-13.5732*x**3
	vmu(i)=0.
	elseif(dist.lt.1221.5)then
	vrho(i)=13.0885-8.8381*x**2
	vlam(i)=11.2622-6.3640*x**2
	vmu(i)=3.6678-4.4475*x**2
	endif

	enddo


	do i=nz-izfree,nz
	vmu(i)=vmu(nz-izfree-1)
	vrho(i)=vrho(nz-izfree-1)
	vlam(i)=vlam(nz-izfree-1)
	enddo

	end
c --------------------------------------------------
c -----------------------------------
c
c progam prem to generate radially symmetric earth models
c
c izfree included  4-8-94

	subroutine premnoc

	include 'common.h'

	ddr=0.001*dmax/(nz-2*izfree)
	re=6371.0

	write(*,*)' Generating Earth model .... '
	write(*,*)' No. of radii  :  ',nz
	write(*,*)' izfree     : ',izfree
	write(*,*)' Max depth :      ',dmax
	write(*,*)' '

	do i=1,nz

	depth=(i-izfree)*ddr
	dist=re-depth
	x=dist/re




c	if(dist.lt.6371.and.dist.ge.6368)then
c	vrho(i)=1.020
c	vlam(i) =1.450
c	vmu(i) =0.
c	if(dist.ge.6356)then
c	vrho(i)=2.6
c	vlam(i)=5.8
c	vmu(i)=3.2
c	elseif(dist.lt.6356.and.dist.ge.6346.6)then 
c	vrho(i)=2.9
c	vlam(i)=6.8
c	vmu(i)=3.9
c	elseif(dist.lt.6346.6.and.dist.ge.6151)then 
	if(dist.ge.6151)then 
	vrho(i)=2.691+.6924*x
	vlam(i)=4.1875+3.9382*x
	vmu(i)=2.1519+2.3481*x
	elseif(dist.lt.6151.and.dist.ge.5971)then 
	vrho(i)=7.1089-3.8045*x
	vlam(i)=20.3926-12.2569*x
	vmu(i)=8.9496-4.4597*x
	elseif(dist.ge.5771)then 
	vrho(i)=11.2494-8.0298*x
	vlam(i)=39.7027-32.6166*x
	vmu(i)=22.3512-18.5856*x
	elseif(dist.lt.5771.and.dist.ge.5701)then 
	vrho(i)=5.3197-1.4836*x
	vlam(i)=19.0957-9.8672*x
	vmu(i)=9.9839-4.9324*x
	elseif(dist.lt.5701.and.dist.ge.5600)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3
	vlam(i)=29.2766-23.6027*x+5.5242*x**2-2.5514*x**3
	vmu(i)=22.3459-17.2473*x-2.0834*x**2+0.9783*x**3
	elseif(dist.lt.5600.and.dist.ge.3630)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3
	vlam(i)=24.9520-40.4673*x+51.4832*x**2-26.6419*x**3
	vmu(i)=11.1671-13.7818*x+17.4575*x**2-9.2777*x**3
	elseif(dist.lt.3630.and.dist.ge.3480)then 
	vrho(i)=7.9565-6.4761*x+5.5283*x**2-3.0807*x**3 
	vlam(i)=15.3891-5.3181*x+5.5242*x**2-2.5514*x**3
	vmu(i)=6.9254+1.4672*x-2.0834*x**2+.9783*x**3
	elseif(dist.lt.3480.and.dist.ge.1221.5)then 
	vrho(i)=12.5815-1.2638*x-3.6426*x**2-5.5281*x**3
	vlam(i)=11.0487-4.0362*x+4.8023*x**2-13.5732*x**3
	vmu(i)=0.
	elseif(dist.lt.1221.5)then
	vrho(i)=13.0885-8.8381*x**2
	vlam(i)=11.2622-6.3640*x**2
	vmu(i)=3.6678-4.4475*x**2
	endif

	enddo


	do i=nz-izfree,nz
	vmu(i)=vmu(nz-izfree-1)
	vrho(i)=vrho(nz-izfree-1)
	vlam(i)=vlam(nz-izfree-1)
	enddo

	end
c --------------------------------------------------
 
c -----------------------------------
c
c progam prem to generate radially symmetric earth models
c
c izfree included  4-8-94

	subroutine homo

	include 'common.h'

	ddr=0.001*dmax/(nz-2*izfree)
	re=6371.0

	write(*,*)' Generating Earth model .... '
	write(*,*)' No. of radii  :  ',nz
	write(*,*)' izfree     : ',izfree
	write(*,*)' Max depth :      ',dmax
	write(*,*)' '

	do i=1,nz

	depth=(i-izfree)*ddr
	dist=re-depth
	x=dist/re




	if(dist.ge.3480.)then 
	vrho(i)=5.
	vlam(i)=13.163
	vmu(i)=6.5
	else
	vrho(i)=9.5
	vlam(i)=8.06
	vmu(i)=0.
	endif

	enddo


	do i=nz-izfree,nz
	vmu(i)=vmu(nz-izfree-1)
	vrho(i)=vrho(nz-izfree-1)
	vlam(i)=vlam(nz-izfree-1)
	enddo

	end
c --------------------------------------------------
 
c -----------------------------------
c
c progam prem to generate radially symmetric earth models
c
c izfree included  4-8-94

	subroutine prem_mhw

	include 'common.h'

	real md(71)
	real mvp(71)
	real mvs(71)
	real mrho(71)


	ddr=0.001*dmax/(nz-2*izfree)
	re=6371.0

	write(*,*)' Read model from file '
	write(*,*)' '
	open(unit=49,file='MODEL/model_mhw',status='unknown')
	read(49,*)
	do i=1,71
	read(49,*)md(i),mvp(i),mvs(i),mrho(i)
c	write(*,*)md(i),mvp(i),mvs(i),mrho(i)
	enddo
	close(unit=49)

	do i=1,nz

	depth=(i-izfree)*ddr


		if(depth.le.md(1))then
		vlam(i)=mvp(1)
		vmu(i)=mvs(1)
		vrho(i)=mrho(1)
		endif

		if(depth.ge.md(1))then
		
		  do j=1,70
		    if(depth.gt.md(j).and.depth.lt.md(j+1))then
		    ddepth=depth-md(j)
		    rmdepth=md(j+1)-md(j)
		    vlam(i)=mvp(j)+(mvp(j+1)-mvp(j))/rmdepth*ddepth 
		    vmu(i)=mvs(j)+(mvs(j+1)-mvs(j))/rmdepth*ddepth 
		    vrho(i)=mrho(j)+(mrho(j+1)-mrho(j))/rmdepth*ddepth 
		    goto 99
		    endif
		  enddo
                
 99		continue
		endif	  	

	enddo

	do i=nz-izfree,nz
	vmu(i)=vmu(nz-izfree-1)
	vrho(i)=vrho(nz-izfree-1)
	vlam(i)=vlam(nz-izfree-1)
	enddo

	end
c --------------------------------------------------
c -----------------------------------
c
c progam prem to generate radially symmetric earth models
c
c izfree included  4-8-94

	subroutine prem_mhw_pwdk(dddp)

	include 'common.h'

	real md(71)
	real mvp(71)
	real mvs(71)
	real mrho(71)

c	write(*,*)' Upper boundary of DDP ',dddp


	ddr=0.001*dmax/(nz-2*izfree)
	re=6371.0

c	write(*,*)' Read model from file '
c	write(*,*)' '
	open(unit=49,file='MODEL/model_mhw',status='unknown')
	read(49,*)
	do i=1,71
	read(49,*)md(i),mvp(i),mvs(i),mrho(i)
c	write(*,*)md(i),mvp(i),mvs(i),mrho(i)
	enddo
	close(unit=49)

	do i=1,nz

	depth=(i-izfree)*ddr


		if(depth.le.md(1))then
		vlam(i)=mvp(1)
		vmu(i)=mvs(1)
		vrho(i)=mrho(1)
		endif

		if(depth.ge.md(1))then
		
		  do j=1,70
		    if(depth.gt.md(j).and.depth.lt.md(j+1))then
		    ddepth=depth-md(j)
		    rmdepth=md(j+1)-md(j)
		    vlam(i)=mvp(j)+(mvp(j+1)-mvp(j))/rmdepth*ddepth 
		    vmu(i)=mvs(j)+(mvs(j+1)-mvs(j))/rmdepth*ddepth 
		    vrho(i)=mrho(j)+(mrho(j+1)-mrho(j))/rmdepth*ddepth 
		    goto 99
		    endif
		  enddo
                
 99		continue
		endif	  	

	enddo

	do i=1,nz
	depth=(i-izfree)*ddr

c setting the DDP top according to dddp

	if(depth>=2300.and.depth<=dddp)then
	vlam(i)=13.163+(depth-2300)*(13.257-13.143)/(2600.-2300.)
	elseif(depth>dddp.and.depth<=2891)then
	vlam(i)=13.714-(2891.-depth)*(13.714-13.657)/(2891.-2600.)
	endif

	enddo

	do i=nz-izfree,nz
	vmu(i)=vmu(nz-izfree-1)
	vrho(i)=vrho(nz-izfree-1)
	vlam(i)=vlam(nz-izfree-1)
	enddo

	end

C ------------------------------------------------

	subroutine fd_absorb_model

	include 'common.h'
	real taper(nx)

c taper parameters

	nabs=nabsorb

	aabs=3.*nabs
	
c initialise spatial window

	window=1.
	do i=1,nabs
	taper(nabs+1-i)=exp(-1./aabs**2*(i-1)**2)	
	enddo
	
	do i=1,nabs
	window(:,nz+1-i)=taper(i)
	enddo
	write(*,*)minval(window),' < window < ',maxval(window)

	return
	end


c ---------------------------------------------

	subroutine  rint(x,nx,xr,f,out)

c this routine interpolates linearly a scalar field known at 
c x(nx) and y(ny) locations to an arbitrary location
c within xmax and ymax.
c The receiver locations are xr,  the scalar input
c field is plane and the function value at xr  is
c out.

	real x(nx)
	real xr,out
	real f(nx)

	do i=1,nx-1
	if(xr .ge. x(i) .and. xr .lt. x(i+1) ) then
	ilow=i
	iup =i+1
	dx=x(i+1)-x(i)
	hx=xr-x(i)
	endif
	enddo

	f1=f(ilow)
	f2=f(iup)

	out = f1 + (f2-f1)/dx*hx

	return
	end

c ---------

        subroutine time_check(i,nt,icheck,t0)

        diff=secnds(t0)

        write(*,*)' Pred. total: ',diff/icheck*nt/60,'min.
     &   (',diff/icheck*nt/3600,'hrs) -> ',100*real(i)/real(nt),'% done '

	t0=secnds(0.0)

        return
        end

	subroutine psv_check

	include 'common.h'
	character*50 file


	write(*,*)' ----------------------------- '
	write(*,*)'        The set up  '
	write(*,*)' ----------------------------- '
	write(*,*)' '
	write(*,*)' seisfile       :  ',seisfile
	write(*,*)' recfile        :  ',recfile
	write(*,*)' snapfile       :  ',snapfile
	write(*,*)' '
	write(*,*)' nx		:  ',nx
	write(*,*)' nz		:  ',nz
	write(*,*)' nt		:  ',nt
	write(*,*)' '
	write(*,*)' dr		:  ',dr
	write(*,*)' dphi     	:  ',dphi
	write(*,*)' dt		:  ',dt
	write(*,*)' izfree	:  ',izfree
	write(*,*)' iord	:  ',iord
	write(*,*)' nop    	:  ',nop
	write(*,*)' nabsorb	:  ',nabsorb
	write(*,*)' aabsorb	:  ',aabsorb
	write(*,*)' '
	write(*,*)' model_type  :  ',model_type
	write(*,*)' vs0         :  ',vs0
	write(*,*)' vp0         :  ',vp0
	write(*,*)' rho0        :  ',rho0
	write(*,*)' '
	write(*,*)' isx         :  ',isx
	write(*,*)' sdepth      :  ',sdepth


c calculate source depth index

	   do iz=1,nz-1
                depth1=rmax-vr2(iz)
                depth2=rmax-vr2(iz+1)
                if(sdepth.gt.depth1.and.sdepth.lt.depth2)then
                        if(sdepth-depth1.le.depth2-sdepth)then
                        isz=iz
                	else
                        isz=iz+1
                	endif
		endif
           enddo

	write(*,*)' isz         :  ',isz
	write(*,*)' Source depth : ',vr2(izfree)-(vr2(isz)+vr2(isz+1))/2.
	write(*,*)' aa          :  ',aa
	write(*,*)' it0         :  ',it0
	write(*,*)' alpha       :  ',alpha
	write(*,*)' source_type :  ',source_type
	write(*,*)' '
	write(*,*)' Rmax        :  ',Rmax
	write(*,*)' MaxR        :  ',vr1(1)
	write(*,*)' MinR        :  ',vr2(nz)
	write(*,*)' '
	write(*,*)' Rfree (u_theta) : ',vr1(izfree)
	write(*,*)' Rfree (u_rad) : ',vr2(izfree)
	write(*,*)' '
	write(*,*)' icheck : ',icheck
	write(*,*)' icheckpoint : ',icheckpoint
	write(*,*)' '
	write(*,*)' Thetamin	:  ',vtheta1(1)
	write(*,*)' Thetamax    :  ',vtheta2(nx)
	write(*,*)' Max darc    :  ',vr1(1)*dphi	
	write(*,*)' Min darc    :  ',vr2(nz)*dphi	
	write(*,*)' '
	write(*,*)' Max(vp)     :  ',maxval(sqrt((lam+2*mu)/rho))
	write(*,*)' Min(vp)     :  ',minval(sqrt((lam+2*mu)/rho))
	write(*,*)' Max(vs)     :  ',maxval(sqrt(mu/rho))
	write(*,*)' Min(vs)     :  ',minval(sqrt(mu/rho))
	write(*,*)' Max(rho)     :  ',maxval(rho)
	write(*,*)' Min(rho)     :  ',minval(rho)
	write(*,*)' '
	write(*,*)' Stability factor (r)     :  ',maxval(sqrt((lam+2*mu)/rho))*dt/dr
c	write(*,*)' Stability factor (theta) min:  ',maxval(sqrt((lam+2*mu)/rho))*dt/(vr1(1)*dphi)
	write(*,*)' Stability factor (Alter) min:  ',(maxval(sqrt((lam+2*mu)/rho))*dt/dr)**2*
     & 	(1+  (dr/(vr1(1)*dphi))**2 )
c	write(*,*)' Stability factor (theta) max:  ',maxval(sqrt((lam+2*mu)/rho))*dt/(vr1(nz)*dphi)
	write(*,*)' Stability factor (Alter) max:  ',(maxval(sqrt((lam+2*mu)/rho))*dt/dr)**2*
     & 	(1+  (dr/(vr1(nz)*dphi))**2 )
	write(*,*)' '
	write(*,*)' Receivers '
	write(*,*)' ixa           : ',ixa
	write(*,*)' ixe           : ',ixe
	write(*,*)' Receiver depth (r) ',vr1(izfree)-vr1(izrec)
	write(*,*)' '
	do i=1,nr
	write(*,*)' Receiver (u_r) : ',i,' Theta : ',rec_loc(i)
	enddo
	write(*,*)' '
	write(*,*)' izrec           : ',izrec
	write(*,*)' isamp           : ',isamp
	write(*,*)' isnap          :  ',isnap
	write(*,*)' '


c model output

	file=seisfile(1:lnblnk(seisfile))//'_model'
	open(10,file=file,status='unknown')
	write(10,*)'  iz        depth         rho             vs               vp '	
	do iz=1,nz
	write(10,4)iz,(rmax-r1(1,iz))/1000.,rho(1,iz),sqrt(mu(1,iz)/rho(1,iz)),
     &                     sqrt((lam(1,iz)+2*mu(1,iz))/rho(1,iz))
	enddo
	close(10)

 4	format(i4,'  ',f10.4,'   ',f10.4,'   ',f10.4,'   ',f10.4)

	write(*,*)' '
	write(*,*)' '
	write(*,*)' '
	write(*,*)' Starting time evolution for ',nt,' time steps  '
	write(*,*)' on ',number_of_processors(),' processors '
	write(*,*)' '
	write(*,*)' '
	write(*,*)' '
	return
	end

C ------------------------------------------------

	subroutine fd_absorb_model

	include 'common.h'
	real taper(nx)

c taper parameters

	aabs=3.*nabs
	
c initialise spatial window

	window=1.
	tmp=1.
	do i=1,nabs
	taper(nabs+1-i)=exp(-1./aabs**2*(i-1)**2)	
	enddo
	

	do i=1,nabs
	window(i,:)=taper(i)
	window(nx+1-i,:)=taper(i)
	tmp(:,i)=taper(i)
	tmp(:,nz+1-i)=taper(i)
	enddo
	window=window*tmp
	window=window/maxval(window)
	write(*,*)minval(window),' < window < ',maxval(window)
	
	write(*,*)' Saving window '
        open(unit=20,file=seisfile(1:lnblnk(seisfile))//'_wd',status='unknown')
        do i=1,nx,iout
        do j=1,nz,iout
        write(20,*)window(i,j)
        enddo
        enddo
	close(20)


	return
	end

	subroutine psv_init

	include 'common.h'

	real np


c source

	a=aa

	if(a.eq.0.)then
	so(1,it0)=1.

	else

	do i=1,nt
	t=(i-it0)*dt

c	so(1,i)=-2.*(a**2)*t*exp(-(a*t)**2)
c	so(1,i)=exp(-(a*t)**2)
c	so(1,i)=(2*(pi*aa*t)**2-1)*exp(-(pi*aa*t)**2)

	np=1.

	if(t.lt.aa.and.t.ge.0)then
            so(1,i) = sin (np*pi*t/aa) - (np/(np+2)) * sin ((np+2)*pi*t/aa)
	endif

	enddo

c normalize
	
	smax=0.
	do i=1,nt
	if(abs(so(1,i)).gt.smax)then
	smax=abs(so(1,i))
	endif
	enddo
	do i=1,nt
	so(1,i)=so(1,i)/smax
	enddo

	if(so(1,1).gt..0001)then
	write(*,*)' Source not small enough at it=1 '
	stop
	endif

	endif


c 

	open(unit=10,file=seisfile(1:lnblnk(seisfile))//'_src')
	do i=1,nt
	write(10,*)so(1,i)
	enddo
	close(10)

c initialize Radius

c	forall(iz=1:nz)vr2(iz)=Rmax-(iz-izfree)*dr
c	forall(iz=1:nz)vr1(iz)=vr2(iz)-.5*dr
c
c	forall(ix=1:nx,iz=1:nz)r1(ix,iz)=vr1(iz)
c	forall(ix=1:nx,iz=1:nz)r2(ix,iz)=vr2(iz)

c initialize theta as a function of source location
c the source location is defined one grid poi nt away from the 
c rotational axis

	forall(ix=1:nx-isx+1)vtheta1(isx-1+ix)=0+(ix-1)*dphi
	forall(ix=1:nx-isx+1)vtheta2(isx-1+ix)=0+(ix-1)*dphi-0.5*dphi
c	forall(ix=1:nx)vtheta1(ix)=0+(ix-1)*dphi
c	forall(ix=1:nx)vtheta2(ix)=0+(ix-1)*dphi-0.5*dphi

c set it anti symmetric around isx-1

	forall(ix=1:isx-1)vtheta1(isx-ix)=-vtheta1(isx+ix)	
	forall(ix=1:isx-1)vtheta2(isx-ix)=-vtheta2(isx+1+ix)	

	forall(ix=1:nx,iz=1:nz)theta1(ix,iz)=vtheta1(ix)
	forall(ix=1:nx,iz=1:nz)theta2(ix,iz)=vtheta2(ix)


c initialization

	u=0.
	r1inv=1./r1
	r2inv=1./r2
	rhoinv=1./rho
	
	where(theta1<>0)
	cot1=cos(theta1)/sin(theta1)
	else where 
	cot1=1.
	end where

	cot2=cos(theta2)/sin(theta2)

c source gauss

	if(alpha<>0.)then

	write(*,*)' alpha = ',alpha
        alpha=1./(alpha*alpha)

	zz0=rmax-sdepth

c        do ix=1,nx
c             do iz=1,nz
c             xx=r2(ix,iz)*sin(theta2(ix,iz))
c             zz=r2(ix,iz)*cos(theta2(ix,iz))-zz0
c		write(*,*)xx,zz
c                gauss(ix,iz)=exp( -alpha *( xx**2 + zz**2))
c             enddo
c        enddo

        forall( ix=1:nx,iz=1:nz)
                gauss(ix,iz)=exp( -alpha *( (r2(ix,iz)*sin(theta2(ix,iz)))**2 
     &                                          +  (r2(ix,iz)*cos(theta2(ix,iz))-zz0)**2))
        end forall



	write(*,*)minval(gauss),' < gauss < ',maxval(gauss)

c	open(unit=10,file=seisfile(1:lnblnk(seisfile))//'_gs')
c	do i=1,nx
c	do j=1,nz
c	write(10,*)gauss(i,j)
c	enddo
c	enddo
c	close(10)

	endif

	
c  absorbing boundary

c     absorb=1.

c         if(nabsorb>0) then
c          forall(ix=1:nabsorb)absorb(ix,:)=ix
c           absorb=exp(-aabsorb*absorb**2 )
c	endif

c Initialize the source distance in x
 


	return
	end

c --------------------------------------------------------

	subroutine pder(g,h,f,dx,nx,nz,dir,dim,nop)

        real h  (nx,nz),f   (nx,nz)
        real sum(nx,nz),temp(nx,nz)
        real g(nop)
	integer dir,dim
	real dx

cmf$ layout  h    (:news,:news)
cmf$ layout  f    (:news,:news)
cmf$ layout  sum  (:news,:news)
cmf$ layout  temp (:news,:news)
cmf$ layout  g    (:serial)


C       Central term of convolution sum


	if(dir==1)then
	ig=nop/2
	else
	ig=nop/2+1
	endif

        sum = f*g(ig)/dx

C       Causal terms of convolution sum

        temp=f
        do j=ig+1,nop
                temp=cshift(temp,shift=1,dim=dim)
                sum=sum+g(j)/dx*temp
        enddo

C       Anti-causal terms of convolution sum

        temp=f
        do j=ig-1,1,-1
                temp=cshift(temp,shift=-1,dim=dim)
                sum=sum+g(j)/dx*temp
        enddo

        h=sum

        return
        end


c ----------------------------------------------

        subroutine CONVT(h,f,g,ig,nop,maxnt)

        real h  (maxnt),f   (maxnt)
        real sum(maxnt),temp(maxnt)
        real g(8)

cmf$ layout  h    (:news)
cmf$ layout  f    (:news)
cmf$ layout  sum  (:news)
cmf$ layout  temp (:news)
cmf$ layout  g    (:serial)


C       Central term of convolution sum

        sum = f*g(ig)

C       Causal terms of convolution sum

        temp=f
        do j=ig+1,nop
                temp=cshift(temp,shift=1,dim=1)
                sum=sum+g(j)*temp
        enddo

C       Anti-causal terms of convolution sum

        temp=f
        do j=ig-1,1,-1
                temp=cshift(temp,shift=-1,dim=1)
                sum=sum+g(j)*temp
        enddo

        h=sum

        return
        end
c --------------------------------------------------------

	subroutine inter(g,h,f,nx,nz,dir,dim,nop)

        real h  (nx,nz),f   (nx,nz)
        real sum(nx,nz),temp(nx,nz)
        real g(nop)
	integer dir,dim

cmf$ layout  h    (:news,:news)
cmf$ layout  f    (:news,:news)
cmf$ layout  sum  (:news,:news)
cmf$ layout  temp (:news,:news)
cmf$ layout  g    (:serial)


C       Central term of convolution sum


	if(dir==1)then
	ig=nop/2
	else
	ig=nop/2+1
	endif

        sum = f*g(ig)

C       Causal terms of convolution sum

        temp=f
        do j=ig+1,nop
                temp=cshift(temp,shift=1,dim=dim)
                sum=sum+g(j)*temp
        enddo

C       Anti-causal terms of convolution sum

        temp=f
        do j=ig-1,1,-1
                temp=cshift(temp,shift=-1,dim=dim)
                sum=sum+g(j)*temp
        enddo

        h=sum


        return
        end

	
	subroutine psv_evolution


	include 'common.h'


	real, dimension (nx,nz)  :: rtemp1,rtemp2
	real, dimension (nx,nz) :: e1,e2,e3,e4
!hpf$	distribute (*,block), shadow(0,4) :: rtemp1,rtemp2
!hpf$	distribute (*,block), shadow(0,4) :: e1,e2,e3,e4



	if(mod(it,icheck)==0)then
	write(*,*)' Time step   ',it,':'
	write(*,*)minval(u21),' < v_t < ',maxval(u21)
	write(*,*)minval(u22),' < v_r < ',maxval(u22)
c	write(*,*)minval(window),' < window < ',maxval(window)
	if(maxval(u21)>100..or.maxval(u22)>100.)then
	write(*,*)' unstable at  it = ',it
	stop
	endif
	endif

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Preparation and calculation of accelerations cccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	s1=s1*window
	s2=s2*window
	s3=s3*window
	s4=s4*window

c moments

	if(source_type==2)then
	   if(alpha==0.)then
	   s1(isx:isx+1,isz:isz+1)=s1(isx:isx+1,isz:isz+1)+so(1,it)
	   s2(isx:isx+1,isz:isz+1)=s2(isx:isx+1,isz:isz+1)+so(1,it)
	   s3(isx:isx+1,isz:isz+1)=s3(isx:isx+1,isz:isz+1)+so(1,it)
	   else
	   s1=s1+gauss*so(1,it)
	   s2=s2+gauss*so(1,it)
	   s3=s3+gauss*so(1,it)
	   endif
	endif

c boundary conditions (stress) -> antisymmetry

	forall(iz=1:izfree)s1(:,izfree+1-iz)=-s1(:,izfree+iz)
	forall(iz=1:izfree)s2(:,izfree+1-iz)=-s2(:,izfree+iz)
	forall(iz=1:izfree)s3(:,izfree+1-iz)=-s3(:,izfree+iz)
	forall(iz=1:izfree-1)s4(:,izfree-iz)=-s4(:,izfree+iz)
	s4(:,izfree)=0.	


c calculate acceleration

c e(1,:,:) and e(2,:,:) will carry acc theta and r, resp.
c e(3-4,:,:) act as temporay arrays

c for u_r :
c     e(3,:,:)=d_r sigma_r^r
c     e(4,:,:)=d_theta sigma_theta^r

        call pder(e3,s1,dr,nx,nz,1,2,nop)
        call pder(e4,s4,dphi,nx,nz,-1,1,nop)
	e2 =   r2inv * e4+e3 

	
c     e(1,:,:) = s(1) -> u_r
c     e(3,:,:) = s(2) -> u_r
c     e(4,:,:) = s(3) -> u_r

	call inter(e1,s1,nx,nz,1,2,nop) 
	call inter(e3,s2,nx,nz,1,2,nop) 
	call inter(e4,s3,nx,nz,1,2,nop) 
	call inter(rtemp1,s4,nx,nz,-1,1,nop) 
	e2 = window * rhoinv * ( e2 + r2inv*(2*e1-e3-e4+rtemp1*cot2)) 
	
c for u_theta:

        call pder(e3,s4,dr,nx,nz,-1,2,nop)
        call pder(e4,s3,dphi,nx,nz,1,1,nop)

	forall (ix=1:isx-1)  e1(ix,:) = r1inv(ix,:) * e4(ix,:) + e3(ix,:) 
	forall (ix=isx+1:nx) e1(ix,:) = r1inv(ix,:) * e4(ix,:) + e3(ix,:) 

        call inter(e3,s4,nx,nz,-1,2,nop)
        call inter(e4,s2,nx,nz,1,1,nop)
        call inter(rtemp1,s3,nx,nz,1,1,nop)

	forall (ix=1:isx-1)  e1(ix,:) = e1(ix,:) + r1inv(ix,:)* 
     &       ( (-e4(ix,:)+rtemp1(ix,:))*cot1(ix,:)+3*e3(ix,:) )
	forall (ix=isx+1:nx)  e1(ix,:) = e1(ix,:) + r1inv(ix,:)* 
     &       ( (-e4(ix,:)+rtemp1(ix,:))*cot1(ix,:)+3*e3(ix,:) )

	e1(isx,:) = 0.
	
	e1 = e1*rhoinv*window


c add source term

	if(source_type==1)then
	e2=e2+gauss*so(1,it)*rhoinv
	endif	

ccccccccccccccccccccccccccccccccccccccccccccc
c extrapolate velocities cccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccc

	u21 = u21  + e1*dt
	u22 = u22  + e2*dt

ccccccccccccccccccccccccccccccccccccccccccccc
c end of velocity calculation ccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccc





cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccc preparation and calculation of stresses cccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c symmetry with respect to source location

	forall(ix=1:isx-1)u21(isx-ix,:)  =-u21(isx+ix,:)	
	forall(ix=1:isx)  u22(isx+1-ix,:)= u22(isx+ix,:)	

c free surface


        forall (iz=1:izfree-1) u22(:,izfree-iz)=
     &                                          u22(:,izfree+iz)
        forall (iz=1:izfree) u21(:,izfree+1-iz)=
     &                                          u21(:,izfree+iz)


c eoshift simulations at sides and at bottom

	u21(nx-izfree:nx,:)=0.
	u22(nx-izfree:nx,:)=0.
	u21(:,nz-izfree:nz)=0.
	u22(:,nz-izfree:nz)=0.

	u21=window*u21
	u22=window*u22


c end-of-shift simulation to omit eoshift 


c absorbing boundaries


c calculate strain elements :
c		e1 = eps_r r
c		e2 = eps_phi phi
c		e3 = eps_theta theta
c		e4 = eps_r theta

c e1
c
c e1 = d_r u^r 

	call pder(e1,u22,dr,nx,nz,-1,2,nop)	

c e2 = u^r/r + 1/r cotg theta u^theta

	call inter(rtemp1,u22,nx,nz,-1,2,nop)
	e2=rtemp1*r1inv

c we need this later

	e3 = e2
	call inter(rtemp1,u21,nx,nz,-1,1,nop)
	e2 = e2+ cot2*rtemp1*r1inv

c e3 = 1/r d_theta u^theta + 1/r u^r

        call pder(rtemp1,u21,dphi,nx,nz,-1,1,nop)
	e3 = e3 + rtemp1*r1inv

c e4 = .5 ( 1/r d_theta u^r + d_r u^theta - 1/r u_theta)

        call pder(rtemp1,u22,dphi,nx,nz,1,1,nop)
	s1=rtemp1	
        call pder(rtemp1,u21,dr,nx,nz,1,2,nop)

	e4 = 0.5*(r2inv*s1 + rtemp1)
        call inter(rtemp1,u21,nx,nz,1,2,nop)
	e4 = e4-0.5*rtemp1*r2inv

c set off diag elements zero at source

	e4(isx,:)=0.

c calculate stress


	s=0.

	s1 = (lam+2*mu)*e1+lam*(e2+e3)
	s2 = (lam+2*mu)*e2+lam*(e1+e3)
	s3 = (lam+2*mu)*e3+lam*(e2+e1)
	s4 = 2*mu*e4

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Extrapolation of stresses cccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	s1= s1o + dt*s1
	s2= s2o + dt*s2
      s3= s3o + dt*s3
      s4= s4o + dt*s4

	s1o=s1
	s2o=s2
	s3o=s3
	s4o=s4


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c End of stress calculation ccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc





	contains

c --------------------------------------------------------

	subroutine pder(h,f,dx,nx,nz,dir,dim,nop)

	real h(nx,nz)
	real f(nx,nz)
!hpf$	distribute *(*,block), shadow(0,4) :: f
!hpf$   align h with f


	parameter(maxnop=8)
        real g(maxnop)
	integer dir,dim
	real dx

c derivative operators

	if(nop==4)then
	g(1)=.0416666666
	g(2)=-1.125
	endif

	if(nop==6)then
	g(1)=-0.00468750000000
     	g(2)= 0.06510416666667
        g(3)=-1.17187500000000
	endif

        if(nop==8)then
        g(1)=0.1344048E-02
        g(2)=-0.1324718E-01
        g(3)=0.8948020E-01
        g(4)=-0.1211563E+01
        endif

c the symmetry

         do i=nop/2+1,nop
          g(i) = -g(nop-i+1)
         enddo

	if (dim == 1) then
	if ( dir == -1 )then

		if(nop==2)then
		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=(f(i,j)-f(i-1,j))/dx	
		end forall
		endif		

		if(nop==4)then
		forall (i=3:nx-3,j=3:nz-3)
		h(i,j)=(g(1)*f(i-2,j)+ 
     &		        g(2)*f(i-1,j)+ 
     &		        g(3)*f(i  ,j)+ 
     &		        g(4)*f(i+1,j))/dx 
		end forall
		endif		

		if(nop==8)then
		forall (i=5:nx-5,j=5:nz-5)
		h(i,j)=(g(1)*f(i-4,j)+ 
     &		        g(2)*f(i-3,j)+ 
     &		        g(3)*f(i-2,j)+ 
     &		        g(4)*f(i-1,j)+ 
     &		        g(5)*f(i  ,j)+ 
     &		        g(6)*f(i+1,j)+ 
     &		        g(7)*f(i+2,j)+ 
     &		        g(8)*f(i+3,j))/dx 
		end forall
		endif		

	else

		if(nop==2)then
		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=(f(i+1,j)-f(i,j))/dx	
		end forall
		endif


		if(nop==4)then
		forall (i=3:nx-3,j=3:nz-3)
		h(i,j)=(g(1)*f(i-1,j)+ 
     &		        g(2)*f(i,j)+ 
     &		        g(3)*f(i+1,j)+ 
     &		        g(4)*f(i+2,j))/dx 
		end forall
		endif		

		if(nop==8)then
		forall (i=5:nx-5,j=5:nz-5)
		h(i,j)=(g(1)*f(i-3,j)+ 
     &		        g(2)*f(i-2,j)+ 
     &		        g(3)*f(i-1,j)+ 
     &		        g(4)*f(i  ,j)+ 
     &		        g(5)*f(i+1,j)+ 
     &		        g(6)*f(i+2,j)+ 
     &		        g(7)*f(i+3,j)+ 
     &		        g(8)*f(i+4,j))/dx 
		end forall
		endif		

	endif

	else

	if ( dir == -1 )then

		if(nop==2)then
		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=(f(i,j)-f(i,j-1))/dx	
		end forall
		endif		

		if(nop==4)then
		forall (i=3:nx-3,j=3:nz-3)
		h(i,j)=(g(1)*f(i,j-2)+ 
     &		        g(2)*f(i,j-1)+ 
     &		        g(3)*f(i,j)+ 
     &		        g(4)*f(i,j+1))/dx 
		end forall
		endif		

		if(nop==8)then
		forall (i=5:nx-5,j=5:nz-5)
		h(i,j)=(g(1)*f(i,j-4)+ 
     &		        g(2)*f(i,j-3)+ 
     &		        g(3)*f(i,j-2)+ 
     &		        g(4)*f(i,j-1)+ 
     &		        g(5)*f(i,j)+ 
     &		        g(6)*f(i,j+1)+ 
     &		        g(7)*f(i,j+2)+ 
     &		        g(8)*f(i,j+3))/dx 
		end forall
		endif		

	else

		if(nop==2)then
		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=(f(i,j+1)-f(i,j))/dx	
		end forall
		endif


		if(nop==4)then
		forall (i=3:nx-3,j=3:nz-3)
		h(i,j)=(g(1)*f(i,j-1)+ 
     &		        g(2)*f(i,j)+ 
     &		        g(3)*f(i,j+1)+ 
     &		        g(4)*f(i,j+2))/dx 
		end forall
		endif		

		if(nop==8)then
		forall (i=5:nx-5,j=5:nz-5)
		h(i,j)=(g(1)*f(i,j-3)+ 
     &		        g(2)*f(i,j-2)+ 
     &		        g(3)*f(i,j-1)+ 
     &		        g(4)*f(i,j)+ 
     &		        g(5)*f(i,j+1)+ 
     &		        g(6)*f(i,j+2)+ 
     &		        g(7)*f(i,j+3)+ 
     &		        g(8)*f(i,j+4))/dx 
		end forall
		endif		
	endif
	endif
	

        end subroutine pder


c --------------------------------------------------------

	subroutine inter(h,f,nx,nz,dir,dim,nop)

	real h(nx,nz)
	real f(nx,nz)
!hpf$	distribute *(*,block), shadow (0,4) :: f
!hpf$   align h with f

	integer dir,dim
	real dx

	if (dim == 1) then
	   if ( dir == -1 )then

		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=0.5*(f(i,j)+f(i-1,j))
		end forall

	else

		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=0.5*(f(i+1,j)+f(i,j))
		end forall

	endif

	else

	if ( dir == -1 )then

		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=0.5*(f(i,j)+f(i,j-1))
		end forall

	else

		forall (i=2:nx-1,j=2:nz-1)
		h(i,j)=0.5*(f(i,j+1)+f(i,j))
		end forall

	endif

	endif
	

        end subroutine inter

	end subroutine psv_evolution	
